
const packChildren = (data) => {
  // for (var x = 0; x < arr.length; x++) {
  //   if (arr[x].FatherId === '-1') {
  //     arr[x].FatherId = 'root'
  //   }
  // }
  // arr.unshift({
  //   MenuId: 'root',
  //   MenuName: '根目录',
  //   Icon: '',
  //   FatherID: '-1',
  //   Url: 'system',
  //   IsShow: 1
  // })
  // console.log(JSON.stringify(arr))
  // for (var n = 0; n < arr.length; n++) {
  //   arr[n].children = []
  //   for (var a = 0; a < arr.length; a++) {
  //     if (arr[n].MenuId === arr[a].FatherId) {
  //       arr[n].children.push(arr[a])
  //     }
  //   }
  // }
  // console.log(JSON.stringify(arr))
  // return arr[0].children

  let cp = data.slice()
  const res = []

  data.forEach((it, inx) => {
    let found = false
    for (let i = 0; i < cp.length; i += 1) {
      if (cp[i].MenuId === it.FatherId) {
        found = true
        cp[i].children = [...(cp[i].children || []), cp[inx]]
        break
      }
    }

    if (!found) {
      res.push(cp[inx])
    }
  })

  return res
}

export default {
  namespaced: true,
  state: {
    cases: [],
    menus: [],
    roles: [],
    user: {}
  },
  mutations: {
    init (state, data) { // 这里的state对应着上面这个state
      state.cases = data.cases
      state.menusRaw = data.menus
      state.roles = data.roles
      state.user = data.user
      state.menus = packChildren(data.menus)
    }
  },
  actions: {
    updateSystemInfo (context) { // 这里的context和我们使用的$store拥有相同的对象和方法
      this.$ajax(this.$api.system.init.url, {
        method: this.$api.system.init.method
      })
        .then(res => {
          context.commit('init', res)
        })
    }
  }
}
